import { NestedTreeControl } from '@angular/cdk/tree';
import * as i0 from '@angular/core';
import { Component, Input, EventEmitter, Output, NgModule } from '@angular/core';
import * as i7 from '@angular/forms';
import { ControlContainer, FormGroupDirective, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i4 from '@angular/material/tree';
import { MatTreeNestedDataSource, MatTreeModule } from '@angular/material/tree';
import { of } from 'rxjs';
import * as i1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i2 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i3 from '@angular/material/core';
import * as i5 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i8 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { MatInputModule } from '@angular/material/input';

class MatTreeSelectInputComponent {
    constructor() {
        this.controlName = {};
        this.options = [];
        this.placeholder = '';
        this.multiple = false;
        this.heading = "";
        this.canSelectParentNode = true;
        this._getChildren = (node) => of(node.children);
        this.hasNestedChild = (_, nodeData) => {
            return (nodeData.children?.length > 0);
        };
        this.nestedTreeControl = new NestedTreeControl(this._getChildren);
        this.nestedDataSource = new MatTreeNestedDataSource();
    }
    ngOnInit() {
        this.nestedDataSource.data = this.options;
    }
    ngOnChanges(changes) {
        if (changes.options?.currentValue !== changes.options?.previousValue) {
            this.nestedDataSource.data = this.options;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.3", type: MatTreeSelectInputComponent, isStandalone: false, selector: "ngx-mat-tree-select-input", inputs: { controlName: "controlName", options: "options", placeholder: "placeholder", multiple: "multiple", heading: "heading", canSelectParentNode: "canSelectParentNode" }, usesOnChanges: true, ngImport: i0, template: "<mat-form-field appearance=\"outline\">\n  <mat-select [id]=\"controlName\" [placeholder]=\"placeholder\" [multiple]=\"multiple\" [formControlName]=\"controlName\">\n    <ng-content></ng-content>\n    <mat-tree class=\"mat-select-tree\" [dataSource]=\"nestedDataSource\" [treeControl]=\"nestedTreeControl\">\n      <mat-tree-node *matTreeNodeDef=\"let node\">\n        <mat-option class=\"option\" [title]=\"node.name\" [value]=\"node\">\n          {{node.name}}\n        </mat-option>\n      </mat-tree-node>\n      <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasNestedChild\">\n        <div class=\"option-wrapper\">\n          <button class=\"tree-toggle\" mat-icon-button matTreeNodeToggle [attr.aria-label]=\"'toggle ' + node.name\">\n            <mat-icon>\n              {{nestedTreeControl.isExpanded(node) ? 'expand_more' : 'chevron_right'}}\n            </mat-icon>\n          </button>\n          <mat-option class=\"option\" [title]=\"node.name\" [disabled]=\"!canSelectParentNode\" [value]=\"node\">\n            {{node.name}}\n          </mat-option>\n        </div>\n        <ul [class.mat-select-tree-hide]=\"!nestedTreeControl.isExpanded(node)\">\n          <span class=\"heading\" *ngIf=\"heading !== ''\"> {{heading + \" \" + node.name}}</span>\n          <ng-container matTreeNodeOutlet></ng-container>\n        </ul>\n      </mat-nested-tree-node>\n    </mat-tree>\n  </mat-select>\n</mat-form-field>\n", styles: [".mat-select-tree-hide{display:none}.tree-toggle{position:relative}.option-wrapper{display:flex}.option{flex:1;width:100%}.heading{margin:4px 0}\n"], dependencies: [{ kind: "component", type: i1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "component", type: i2.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i4.MatNestedTreeNode, selector: "mat-nested-tree-node", inputs: ["matNestedTreeNode", "disabled", "tabIndex"], outputs: ["activation", "expandedChange"], exportAs: ["matNestedTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeDef, selector: "[matTreeNodeDef]", inputs: ["matTreeNodeDefWhen", "matTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeToggle, selector: "[matTreeNodeToggle]", inputs: ["matTreeNodeToggleRecursive"] }, { kind: "component", type: i4.MatTree, selector: "mat-tree", exportAs: ["matTree"] }, { kind: "directive", type: i4.MatTreeNode, selector: "mat-tree-node", inputs: ["tabIndex", "disabled"], outputs: ["activation", "expandedChange"], exportAs: ["matTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeOutlet, selector: "[matTreeNodeOutlet]" }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i7.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: i8.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }], viewProviders: [
            {
                provide: ControlContainer,
                useExisting: FormGroupDirective
            }
        ] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-mat-tree-select-input', viewProviders: [
                        {
                            provide: ControlContainer,
                            useExisting: FormGroupDirective
                        }
                    ], standalone: false, template: "<mat-form-field appearance=\"outline\">\n  <mat-select [id]=\"controlName\" [placeholder]=\"placeholder\" [multiple]=\"multiple\" [formControlName]=\"controlName\">\n    <ng-content></ng-content>\n    <mat-tree class=\"mat-select-tree\" [dataSource]=\"nestedDataSource\" [treeControl]=\"nestedTreeControl\">\n      <mat-tree-node *matTreeNodeDef=\"let node\">\n        <mat-option class=\"option\" [title]=\"node.name\" [value]=\"node\">\n          {{node.name}}\n        </mat-option>\n      </mat-tree-node>\n      <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasNestedChild\">\n        <div class=\"option-wrapper\">\n          <button class=\"tree-toggle\" mat-icon-button matTreeNodeToggle [attr.aria-label]=\"'toggle ' + node.name\">\n            <mat-icon>\n              {{nestedTreeControl.isExpanded(node) ? 'expand_more' : 'chevron_right'}}\n            </mat-icon>\n          </button>\n          <mat-option class=\"option\" [title]=\"node.name\" [disabled]=\"!canSelectParentNode\" [value]=\"node\">\n            {{node.name}}\n          </mat-option>\n        </div>\n        <ul [class.mat-select-tree-hide]=\"!nestedTreeControl.isExpanded(node)\">\n          <span class=\"heading\" *ngIf=\"heading !== ''\"> {{heading + \" \" + node.name}}</span>\n          <ng-container matTreeNodeOutlet></ng-container>\n        </ul>\n      </mat-nested-tree-node>\n    </mat-tree>\n  </mat-select>\n</mat-form-field>\n", styles: [".mat-select-tree-hide{display:none}.tree-toggle{position:relative}.option-wrapper{display:flex}.option{flex:1;width:100%}.heading{margin:4px 0}\n"] }]
        }], ctorParameters: () => [], propDecorators: { controlName: [{
                type: Input
            }], options: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], multiple: [{
                type: Input
            }], heading: [{
                type: Input
            }], canSelectParentNode: [{
                type: Input
            }] } });

class MatTreeSelectInputNgmodelComponent {
    constructor() {
        this.select = "";
        this.selectChange = new EventEmitter();
        this.selectionChanged = new EventEmitter();
        this.options = [];
        this.placeholder = '';
        this.multiple = false;
        this.heading = "";
        this.canSelectParentNode = true;
        this._getChildren = (node) => of(node.children);
        this.hasNestedChild = (_, nodeData) => {
            return (nodeData.children?.length > 0);
        };
        this.nestedTreeControl = new NestedTreeControl(this._getChildren);
        this.nestedDataSource = new MatTreeNestedDataSource();
    }
    ngOnInit() {
        this.nestedDataSource.data = this.options;
    }
    ngOnChanges(changes) {
        if (changes.options?.currentValue !== changes.options?.previousValue) {
            this.nestedDataSource.data = this.options;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputNgmodelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.3", type: MatTreeSelectInputNgmodelComponent, isStandalone: false, selector: "ngx-mat-tree-select-input-ngmodel", inputs: { select: "select", options: "options", placeholder: "placeholder", multiple: "multiple", heading: "heading", canSelectParentNode: "canSelectParentNode" }, outputs: { selectChange: "selectChange", selectionChanged: "selectionChanged" }, usesOnChanges: true, ngImport: i0, template: "<mat-form-field appearance=\"outline\">\n  <mat-select [placeholder]=\"placeholder\" [multiple]=\"multiple\" (selectionChange)='selectionChanged.emit(select)'\n    [(ngModel)]=\"select\" (ngModelChange)=\"selectChange.emit(select)\">\n    <ng-content></ng-content>\n    <mat-tree class=\"mat-select-tree\" [dataSource]=\"nestedDataSource\" [treeControl]=\"nestedTreeControl\">\n      <mat-tree-node *matTreeNodeDef=\"let node\">\n        <mat-option class=\"option\" [title]=\"node.name\" [value]=\"node\">\n          {{node.name}}\n        </mat-option>\n      </mat-tree-node>\n      <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasNestedChild\">\n        <div class=\"option-wrapper\">\n          <button class=\"tree-toggle\" mat-icon-button matTreeNodeToggle [attr.aria-label]=\"'toggle ' + node.name\">\n            <mat-icon>\n              {{nestedTreeControl.isExpanded(node) ? 'expand_more' : 'chevron_right'}}\n            </mat-icon>\n          </button>\n          <mat-option class=\"option\" [title]=\"node.name\" [disabled]=\"!canSelectParentNode\" [value]=\"node\">\n            {{node.name}}\n          </mat-option>\n        </div>\n        <ul [class.mat-select-tree-hide]=\"!nestedTreeControl.isExpanded(node)\">\n          <span *ngIf=\"heading !== ''\" class=\"heading\"> {{heading + \" \" + node.name}}</span>\n          <ng-container matTreeNodeOutlet></ng-container>\n        </ul>\n      </mat-nested-tree-node>\n    </mat-tree>\n  </mat-select>\n</mat-form-field>\n", styles: [".mat-select-tree-hide{display:none}.tree-toggle{position:relative}.option-wrapper{display:flex}.option{flex:1;width:100%}.heading{margin:4px 0}\n"], dependencies: [{ kind: "component", type: i1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "component", type: i2.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i4.MatNestedTreeNode, selector: "mat-nested-tree-node", inputs: ["matNestedTreeNode", "disabled", "tabIndex"], outputs: ["activation", "expandedChange"], exportAs: ["matNestedTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeDef, selector: "[matTreeNodeDef]", inputs: ["matTreeNodeDefWhen", "matTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeToggle, selector: "[matTreeNodeToggle]", inputs: ["matTreeNodeToggleRecursive"] }, { kind: "component", type: i4.MatTree, selector: "mat-tree", exportAs: ["matTree"] }, { kind: "directive", type: i4.MatTreeNode, selector: "mat-tree-node", inputs: ["tabIndex", "disabled"], outputs: ["activation", "expandedChange"], exportAs: ["matTreeNode"] }, { kind: "directive", type: i4.MatTreeNodeOutlet, selector: "[matTreeNodeOutlet]" }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i7.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i8.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputNgmodelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-mat-tree-select-input-ngmodel', standalone: false, template: "<mat-form-field appearance=\"outline\">\n  <mat-select [placeholder]=\"placeholder\" [multiple]=\"multiple\" (selectionChange)='selectionChanged.emit(select)'\n    [(ngModel)]=\"select\" (ngModelChange)=\"selectChange.emit(select)\">\n    <ng-content></ng-content>\n    <mat-tree class=\"mat-select-tree\" [dataSource]=\"nestedDataSource\" [treeControl]=\"nestedTreeControl\">\n      <mat-tree-node *matTreeNodeDef=\"let node\">\n        <mat-option class=\"option\" [title]=\"node.name\" [value]=\"node\">\n          {{node.name}}\n        </mat-option>\n      </mat-tree-node>\n      <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasNestedChild\">\n        <div class=\"option-wrapper\">\n          <button class=\"tree-toggle\" mat-icon-button matTreeNodeToggle [attr.aria-label]=\"'toggle ' + node.name\">\n            <mat-icon>\n              {{nestedTreeControl.isExpanded(node) ? 'expand_more' : 'chevron_right'}}\n            </mat-icon>\n          </button>\n          <mat-option class=\"option\" [title]=\"node.name\" [disabled]=\"!canSelectParentNode\" [value]=\"node\">\n            {{node.name}}\n          </mat-option>\n        </div>\n        <ul [class.mat-select-tree-hide]=\"!nestedTreeControl.isExpanded(node)\">\n          <span *ngIf=\"heading !== ''\" class=\"heading\"> {{heading + \" \" + node.name}}</span>\n          <ng-container matTreeNodeOutlet></ng-container>\n        </ul>\n      </mat-nested-tree-node>\n    </mat-tree>\n  </mat-select>\n</mat-form-field>\n", styles: [".mat-select-tree-hide{display:none}.tree-toggle{position:relative}.option-wrapper{display:flex}.option{flex:1;width:100%}.heading{margin:4px 0}\n"] }]
        }], ctorParameters: () => [], propDecorators: { select: [{
                type: Input
            }], selectChange: [{
                type: Output
            }], selectionChanged: [{
                type: Output
            }], options: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], multiple: [{
                type: Input
            }], heading: [{
                type: Input
            }], canSelectParentNode: [{
                type: Input
            }] } });

class MatTreeSelectInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputModule, declarations: [MatTreeSelectInputComponent,
            MatTreeSelectInputNgmodelComponent], imports: [MatInputModule,
            MatFormFieldModule,
            MatSelectModule,
            MatTreeModule,
            MatIconModule,
            CommonModule,
            ReactiveFormsModule,
            FormsModule,
            MatButtonModule], exports: [MatTreeSelectInputComponent,
            MatTreeSelectInputNgmodelComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputModule, imports: [MatInputModule,
            MatFormFieldModule,
            MatSelectModule,
            MatTreeModule,
            MatIconModule,
            CommonModule,
            ReactiveFormsModule,
            FormsModule,
            MatButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: MatTreeSelectInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MatTreeSelectInputComponent,
                        MatTreeSelectInputNgmodelComponent
                    ],
                    imports: [
                        MatInputModule,
                        MatFormFieldModule,
                        MatSelectModule,
                        MatTreeModule,
                        MatIconModule,
                        CommonModule,
                        ReactiveFormsModule,
                        FormsModule,
                        MatButtonModule
                    ],
                    exports: [
                        MatTreeSelectInputComponent,
                        MatTreeSelectInputNgmodelComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of mat-tree-select-input
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MatTreeSelectInputComponent, MatTreeSelectInputModule, MatTreeSelectInputNgmodelComponent };
//# sourceMappingURL=mat-tree-select-input.mjs.map
